@echo off
chcp 65001 >nul
cls

:: Define Colors (Only Works in Windows 10+)
set "RED=[31m"
set "GREEN=[32m"
set "YELLOW=[33m"
set "BLUE=[34m"
set "CYAN=[36m"
set "MAGENTA=[35m"
set "RESET=[0m"


:: Header Banner
echo ================================================================
echo                %CYAN%WELCOME TO OVERAIM LAUNCHER v2%RESET%
echo ================================================================
echo.
echo   %YELLOW%[INFO]%RESET% Press %GREEN%INSERT%RESET% to open the menu in-game.
echo   %YELLOW%[INFO]%RESET% Ensure overlays are disabled for best performance.
echo   %YELLOW%[INFO]%RESET% If you experience issues, run as administrator.
echo ================================================================
echo.
timeout /t 3 >nul

:: Animated Title with a Loop
setlocal enabledelayedexpansion
for %%i in (1 2 3 4 5 6 7 8 9 10) do (
    title Overaim.v2 - Launching Script %%i...
    timeout /t 1 >nul
)

:: Check if Python is Installed
python --version >nul 2>&1
if %errorlevel% neq 0 (
    echo.
    echo %RED%[ERROR]%RESET% Python is not installed or not added to your PATH.
    echo %YELLOW%[INFO]%RESET% Please install Python from: https://www.python.org/downloads/
    echo %YELLOW%[INFO]%RESET% Ensure Python is added to the system PATH during installation.
    echo.
    pause
    exit /b
)

:: Inform User That Python Was Detected
echo.
echo %GREEN%[INFO]%RESET% Python detected successfully!
echo %BLUE%[INFO]%RESET% Verifying Overaim directory structure...
echo.
timeout /t 2 >nul

:: Check for the "extra" Directory
if not exist "%~dp0extra\" (
    echo.
    echo %RED%[ERROR]%RESET% Missing required directory: "extra".
    echo %YELLOW%[INFO]%RESET% Ensure the directory "extra" is located in the same folder as this script.
    echo.
    pause
    exit /b
)

:: Navigate to the Correct Directory and Validate "main.py"
cd /d "%~dp0extra"
if not exist "main.py" (
    echo.
    echo %RED%[ERROR]%RESET% Missing required file: "main.py".
    echo %YELLOW%[INFO]%RESET% Ensure that "main.py" exists in the "extra" folder.
    echo.
    pause
    exit /b
)

:: Check if Visual C++ Redistributable is Installed
reg query "HKLM\SOFTWARE\Microsoft\VisualStudio\14.0\VC\Runtimes\x64" >nul 2>&1
if %errorlevel% neq 0 (
    echo.
    echo %RED%[ERROR]%RESET% Visual C++ Redistributable is missing!
    echo %YELLOW%[INFO]%RESET% Please download and install from:
    echo %YELLOW% https://aka.ms/vs/17/release/vc_redist.x64.exe %RESET%
    echo.
    pause
    exit /b
)

:: Execute the Python Script
echo.
echo %GREEN%[INFO]%RESET% Launching Overaim script...
timeout /t 3 >nul
echo.
py main.py

:: Handle Script Execution Errors
if %errorlevel% neq 0 (
    echo.
    echo %RED%[ERROR]%RESET% An error occurred while running "main.py".
    echo %YELLOW%[INFO]%RESET% Please check the script for issues or review its logs.
    echo.
    pause
    exit /b
)

:: Success Message
echo.
echo ================================================================
echo      %GREEN%OVERAIM LAUNCHER v2 - SCRIPT EXECUTED SUCCESSFULLY!%RESET%
echo ================================================================
echo.
pause
